declare const SNODE: unique symbol, SPROXY: unique symbol;
declare type StateNode = {
    [SNODE]?: any;
    [SPROXY]?: any;
    [k: string]: any;
    [k: number]: any;
};
declare type Partial<T> = {
    [P in keyof T]?: Partial<T[P]>;
};
declare type AddSymbolToPrimitive<T> = T extends {
    [Symbol.toPrimitive]: infer V;
} ? {
    [Symbol.toPrimitive]: V;
} : {};
declare type AddCallable<T> = T extends {
    (...x: any[]): infer V;
} ? {
    (...x: Parameters<T>): V;
} : {};
export declare type Wrapped<T> = {
    [P in keyof T]: T[P] extends object ? Wrapped<T[P]> : T[P];
} & {
    _state: T;
} & AddSymbolToPrimitive<T> & AddCallable<T>;
declare type StateAtom = string | number | boolean | symbol | null | undefined | any[];
declare type StateSetter<T> = (Partial<T> | ((prevState: Wrapped<T>, traversed?: (string | number)[]) => Partial<T>));
declare type NestedStateSetter<T> = StateSetter<T> | StateAtom | ((prevState: StateAtom, traversed?: (string | number)[]) => StateAtom);
declare type StatePathRange = {
    from?: number;
    to?: number;
    by?: number;
};
declare type StatePathPart = string | (string | number)[] | StatePathRange | ((item: any, index: number) => boolean);
export declare function isWrappable(obj: any): boolean;
export declare function unwrap<T extends StateNode>(item: any): T;
export declare function setProperty(state: StateNode, property: string | number, value: any): void;
export declare function createState<T extends StateNode>(state?: T | Wrapped<T>): [Wrapped<T>, {
    (update: Partial<T> | ((prevState: Wrapped<T>, traversed?: (string | number)[] | undefined) => Partial<T>)): void;
    (...path: [string, NestedStateSetter<any>] | [string, StatePathPart, NestedStateSetter<any>] | [string, StatePathPart, StatePathPart, NestedStateSetter<any>] | [string, StatePathPart, StatePathPart, StatePathPart, NestedStateSetter<any>] | [string, StatePathPart, StatePathPart, StatePathPart, StatePathPart, NestedStateSetter<any>] | [string, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StatePathPart, NestedStateSetter<any>] | [string, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StatePathPart, NestedStateSetter<any>]): void;
    (paths: ([string, NestedStateSetter<any>] | [string, StatePathPart, NestedStateSetter<any>] | [string, StatePathPart, StatePathPart, NestedStateSetter<any>] | [string, StatePathPart, StatePathPart, StatePathPart, NestedStateSetter<any>] | [string, StatePathPart, StatePathPart, StatePathPart, StatePathPart, NestedStateSetter<any>] | [string, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StatePathPart, NestedStateSetter<any>] | [string, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StatePathPart, NestedStateSetter<any>])[]): void;
    (reconcile: (s: Wrapped<T>) => void): void;
}];
export {};
